function assertMiddleware(middleware) {
  var entryType = typeof middleware;
  if (entryType !== 'function') {
    throw new TypeError("A segment middleware must be a function, but a " + entryType + " is being passed");
  }
}
export var loadSegmentMiddlewares = function loadSegmentMiddlewares(_ref) {
  var optimizelyUserIdMiddleware = _ref.optimizelyUserIdMiddleware,
    optimizelySiteAttributeMiddleware = _ref.optimizelySiteAttributeMiddleware,
    customSourceMiddlewares = _ref.customSourceMiddlewares,
    _ref$customDestinatio = _ref.customDestinationMiddlewares,
    customDestinationMiddlewares = _ref$customDestinatio === void 0 ? [] : _ref$customDestinatio;
  window.analytics.ready(function () {
    customSourceMiddlewares.forEach(function (middleware) {
      assertMiddleware(middleware);
      window.analytics.addSourceMiddleware(middleware);
    });
    window.analytics.addDestinationMiddleware('Optimizely', [optimizelyUserIdMiddleware, optimizelySiteAttributeMiddleware].concat(customDestinationMiddlewares));
  });
};